<?php

ob_start();
$guest_account = true;
chdir('../..');
include("./include/auth.php");
input_validate_input_number(get_request_var_request("local_graph_id"));
input_validate_input_regex(get_request_var_request("action"),'^(showtable|showchart|showdata)$');
ob_end_clean();
session_write_close();

$lgi = $_REQUEST['local_graph_id'];

if ($_REQUEST['action']=='showchart') {
    include_once dirname(__FILE__).'/ofc/open_flash_chart_object.php';

    echo "<html><head><title>Transporter</tite></head><body>";
    echo open_flash_chart_object( 500, 250, $config['url_path']."plugins/transporter/node_stats.php?local_graph_id=$lgi&action=showdata",true,$config['url_path'].'plugins/transporter/ofc/');
    echo "<input type=button value='back' onclick='javascript:history.back(1)'></body></html>";
    exit(0);
}

if ($_REQUEST['action']=='showdata' || $_REQUEST['action']=='showtable') {
    global $high_breach,$low_breach,$cycles,$table;

    $high_breach=0.85;//alert traffic bigger than 85 percent of it's maximum
    $low_breach=0.01;// alert traffic lower than 1 percent of it's minimum
    $pi=read_config_option("poller_interval");
    
    $data=node_stats($lgi);
    if (!$data || !isset($data['statistics']['traffic_in']) || !isset($data['statistics']['traffic_out'])) {
	die("no traffic_in or traffic_out data on current graph. Transporter must run at least three times(3 polling cycles) before calculations are available.");
    }
}

if ($_REQUEST['action']=='showdata') {
    include_once( dirname(__FILE__).'/ofc/open-flash-chart.php' );

    $to=&$data['data']['traffic_out'];
    foreach ($data['data']['traffic_in'] as $ts=>$val) {
	$x[$ts]=date('h:i',time()+$ts*$pi);
	
	$y[$ts]=$val;
	$f[$ts]=$data['statistics']['traffic_in']['regr']['slope']*$ts+$data['statistics']['traffic_in']['regr']['interc'];
	
	$y2[$ts]=$to[$ts];
	$f2[$ts]=$data['statistics']['traffic_out']['regr']['slope']*$ts+$data['statistics']['traffic_out']['regr']['interc'];
    }
    
    $ymin=min($y);
    $ymax=max(max($y),max($f),max($y2),max($f2));
    $ymin=min(min($y),min($f),min($y2),min($f2))*0.25;
    
    $title=htmlspecialchars($data['details']['name']."\nfor last ".$pi*$cycles." seconds");
    
    $g = new graph();
    $g->title($title, '{font-size: 10px; color: #736AFF}' );
    
    $g->set_data( $y );
    $g->set_data( $f );
    $g->set_data( $y2 );
    $g->set_data( $f2 );

    $g->area_hollow( 2, 3, 25,'0x006400', 'traffic_in', 10);
    $g->line( 1, '0x00FF00', 'traffic_in_linear_fit', 10);
    $g->area_hollow( 2, 3, 25, '0x000064', 'traffic_out', 10);
    $g->line( 1, '0x0000FF', 'traffic_out_linear_fit', 10);
    
    $g->set_x_labels($x);
    $g->set_x_label_style( 10, '0x000', 0, 2 );


    $g->set_y_max( $ymax );
    $g->set_y_min( $ymin );

    $g->set_y_legend( 'bps', 10, '#736AFF' );
    $g->set_x_legend('time',10,'#736AFF');

    echo $g->render();
    exit(0);
}

$time_range=$cycles*$pi;//seconds

$istats=&$data['statistics']['traffic_in'];
$accui=round(sqrt(pow($istats['corr'],2)),2)*100;

$ostats=&$data['statistics']['traffic_out'];
$accuo=round(sqrt(pow($ostats['corr'],2)),2)*100;

$msg_in="traffic is currently ".($istats['regr']['slope']>0 ? 'in' : 'de')."creasing by ".size_readable(abs($istats['regr']['slope']))."ps";
$msg_out="traffic is currently ".($ostats['regr']['slope']>0 ? 'in' : 'de')."creasing by ".size_Readable(abs($ostats['regr']['slope']))."ps";

$func_in=$istats['regr']['function'];
$func_out=$ostats['regr']['function'];

$th_in_hi=(string)$data['alerts']['traffic_in']['hi'];
$th_in_low=(string)$data['alerts']['traffic_in']['low'];
$th_out_hi=(string)$data['alerts']['traffic_out']['hi'];
$th_out_low=(string)$data['alerts']['traffic_out']['low'];

$lim_in_hi=$data['details']['traffic_in']['hi_limit'];
$lim_in_low=$data['details']['traffic_in']['low_limit'];
$lim_out_hi=$data['details']['traffic_out']['hi_limit'];
$lim_out_low=$data['details']['traffic_out']['low_limit'];

$forecast_high_in=($istats['regr']['slope']==0) ? 0 : round(($lim_in_hi-$istats['regr']['interc'])/$istats['regr']['slope'],2);
$forecast_high_in=($forecast_high_in>0) ? $forecast_high_in : 'never';

$forecast_high_out=($ostats['regr']['slope']==0) ? 0 : round(($lim_out_hi-$ostats['regr']['interc'])/$ostats['regr']['slope'],2);
$forecast_high_out=($forecast_high_out>0) ? $forecast_high_out : 'never';

$forecast_low_in=($istats['regr']['slope']==0) ? 0 : round(($lim_in_low-$istats['regr']['interc'])/$istats['regr']['slope'],2);
$forecast_low_in=($forecast_low_in>0) ? $forecast_low_in : 'never';

$forecast_low_out=($ostats['regr']['slope']==0) ? 0 : round(($lim_out_low-$ostats['regr']['interc'])/$ostats['regr']['slope'],2);
$forecast_low_out=($forecast_low_out>0) ? $forecast_low_out : 'never';

echo "<html>
<head>
    <title>Transporter</title>
</head>
<script type='text/javascript'>
function showhide() {
    var sp=document.getElementById('raw');
    if (sp.style.display=='none')
	sp.style.display='block';
    else
	sp.style.display='none';
}

function rrdlessChart(lgi) {
    wnd=window.open('${config['url_path']}plugins/transporter/node_stats.php?local_graph_id='+lgi+'&action=showchart','transporter','menubar=no,toolbar=no,resizable=yes,scrollbars=yes,width=420,height=480');
}
</script>
<body style='font-size:12px'>
    statistics for $cycles cycles ($time_range seconds)<br>
    <table border=1 width='100%' height='80%' style='border-collapse:collapse;font-size:12px'>
    <tr><td colspan=3 align=center>Status <a title='Displays a constant (average) traffic increase/decrease and accuracy of those measurements' style=\"cursor:pointer\"'>?</a></td></tr>
    <tr><td>Direction</td><td>Status</td><td>measuerment accuracy</td></tr>
    <tr><td>Incoming</td><td>$msg_in</td><td>$accui %</td></tr>
    <tr><td>Outgoing</td><td>$msg_out</td><td>$accuo %</td></tr>
    
    <tr><td colspan=3 align=center>Forecasts <a title='Displays after how many poller cycles limit value will be reached' style=\"cursor:pointer\"'>?</a></td></tr>
    <tr><td>Direction</td><td>High limit reach</td><td>Low limit reach</td></tr>
    <tr><td>Incoming</td><td>$forecast_high_in</td><td>$forecast_low_in</td></tr>
    <tr><td>Outgoing</td><td>$forecast_high_in</td><td>$forecast_low_out</td></tr>
    
    <tr><td colspan=3 align=center>1st level polynomial approximation functions <a style='cursor:pointer' title='Simple linear-fit. Theoreticaly we could draw it by extending zoom script'>?</a></td></tr>
    <tr><td>Direction</td><td>Function</td><td>correlation</td></tr>
    <tr><td>Incoming</td><td>$func_in</td><td>${istats['corr']}</td></tr>
    <tr><td>Outgoing</td><td>$func_out</td><td>${ostats['corr']}</td></tr>
    
    <tr><td colspan=3 align=center>Alerts</td></tr>
    <tr><td>Direction</td><td>Hi treshold breach</td><td>Low treshold breach</td></tr>
    <tr><td>Incoming</td><td>$th_in_hi</td><td>$th_in_low</td></tr>
    <tr><td>Outgoign</td><td>$th_out_hi</td><td>$th_out_low</td></tr>
    
    <tr><td colspan=3 align=center>Template limits</td></tr>
    <tr><td>Direction</td><td>Hi treshold breach</td><td>Low treshold breach</td></tr>
    <tr><td>Incoming</td><td>$lim_in_hi</td><td>$lim_in_low</td></tr>
    <tr><td>Outgoign</td><td>$lim_out_hi</td><td>$lim_out_low</td></tr>
</table><br>
<input type=button value='Show/Hide raw data' onclick=showhide()>
<input type=button value='Chart without RRD' onclick=rrdlessChart($lgi)>
<span id=raw style='display:none;background:#DCDCDC'>
<pre>";
print_r($data);
echo "</pre>
</span>
</body></html>";

//correlation and regression
function corr_reg($data) {
    $x=$data['x'];
    $y=$data['y'];
    
    $N = count($data['x']);
    
    $Z_x=array_sum($x);
    $Z_y=array_sum($y);

    $Z_xy=0;
    for ($i=0;$i<$N;$i++)
	$Z_xy+=$x[$i]*$y[$i];
    
    $Z_x2=array_sum(array_map('square',$x));
    $Z_y2=array_sum(array_map('square',$y));
    
    $numenator=$Z_xy-$Z_x*$Z_y/$N;
    $denumenator= sqrt( ($Z_x2-pow($Z_x,2)/$N) * ($Z_y2-pow($Z_y,2)/$N) );
    $corr = ($denumenator > 0) ? $numenator/$denumenator : 0;
    
    $slope = ($Z_xy-($Z_x*$Z_y)/$N)/($Z_x2-($Z_x*$Z_x)/$N);
    $intercept = ($Z_y-$slope*$Z_x)/$N;

    return array(
		    'corr' => $corr,
		    'reg'  => array(
				    'slope'    => $slope,
				    'interc'   => $intercept,
				    'function' => "Y = ".round($slope,2)."*x ".(($intercept>0) ? " + " : " - ").round($intercept,2)
				    )
		);
}

function square($n) {
    return pow($n,2);
}

function size_readable ($size, $retstring = null) {
        $sizes = array('b', 'Kb', 'Mb', 'Gb', 'Tb', 'Pb', 'Eb', 'Zb', 'Yb');
        if ($retstring === null) { $retstring = '%01.2f%s'; }
        $lastsizestring = end($sizes);
        foreach ($sizes as $sizestring) {
                if ($size < 1000) { break; }
                if ($sizestring != $lastsizestring) { $size /= 1000; }
        }
        if ($sizestring == $sizes[0]) { $retstring = '%01d%s'; } // Bytes aren't normally fractional
        return sprintf($retstring, $size, $sizestring);
}

/*
 * this function can be easily extended to support any kind of data-source, that would give us kind of "universal statistics",
 * also, it could read information from rrd's as well.
 * An still, I felt no need for this as it is being used just for demo purposes.
 */
function node_stats($lgi) {
    global $config,$high_breach,$low_breach,$cycles,$table;

    $table=read_config_option("transporter_dbtable");
    if (!$table || $table=='')
	return false;

    $details = lgi_to_ldi($lgi);
    if (!$details) return false;
    
    $ldi = $details['local_data_id'];
    $upper_lim = $details['upper_limit'];
    $lower_lim = $details['lower_limit'];
    $ds_type = $details['data_source_type_id'];
    $title = $details['title_cache'];
    if (!preg_match('/ - (.*) - /',$title,$type)) return false;
    $type = strtolower($type[1]);
    
    $polling_interval = read_config_option("poller_interval");

    
    $sql = "SELECT
	    $table.timestamp,
	    $table.poller_output
	FROM
	    $table
	WHERE
	    local_data_id=$ldi
	GROUP BY
	    timestamp 
	ORDER BY 
	    timestamp";

    $result = db_fetch_assoc($sql);
    if(!$result || empty($result)) return false;
    
    $cycles=count($result);
    if ($cycles<3) return false;
    $cycles--;
    
    $counters=array();
    $traffic['data']=array();
    $alerts=array();

    foreach ($result as $id => $item) {
	//COUNTER
	if ($ds_type==2) {
	    $data = explode(" ",$item['poller_output']);
		foreach ($data as $val) {
		    if (preg_match('/^(.*):(\d{1,})$/',$val,$match))
			$counters[$match[1]][]=$match[2];
		}
	} else {
	    die("only interface-traffic data-templates are supported\n");
	}
	//GAUGE
	    //not yet implemented
    }

    foreach ($counters as $id => $curr_counters) {
	$alerts[$id]['hi']='false';
	$alerts[$id]['low']='false';
	foreach ($curr_counters as $ind => $value) {
	    if ($ind==0) continue;
	    //several lines below are borrowed from thold plugin
	    $curr_val =( ($value >= $curr_counters[$ind-1]) ? $value - $curr_counters[$ind-1] :
                        	( ($curr_counters[$ind-1] > 4294967295) ? (18446744073709551615 - $curr_counters[$ind-1]) + $value :
                    		    (4294967295 - $curr_counters[$ind-1]) + $value ) )*8/$polling_interval;
	    $traffic['data'][$id][] = intval(round($curr_val,2));
	    
	    if ($type=='traffic') {
		if ($curr_val > $upper_lim*$high_breach) {
		    $alerts[$id]['hi']='true';
		}
		if ($curr_val <= $lower_lim*$low_breach) {
		    $alerts[$id]['low']='true';
		}
	    }
	    
	}
    }

    foreach ($traffic['data'] as $id => $item) {
	$xy_data=array();
	foreach ($item as $x => $y) {
	    $xy_data[$id]['x'][$x]=$x;
	    $xy_data[$id]['y'][$x]=$y;
	}
	$corr_reg = corr_reg($xy_data[$id]);
	$traffic['statistics'][$id]['corr']=$corr_reg['corr'];
	$traffic['statistics'][$id]['regr']=$corr_reg['reg'];
	
	$traffic['details'][$id]['hi_limit']=$upper_lim;
	$traffic['details'][$id]['low_limit']=$lower_lim;
    }

    $traffic['alerts']=$alerts;
    $traffic['details']['name']=$title;
    return $traffic;
}

// hope in next cacti release we won't need the following stuff....
function lgi_to_ldi($lgi) {
    global $config,$table;

    $sql = "SELECT
	    data_template_rrd.local_data_id,
	    data_template_rrd.data_source_type_id,
	    graph_templates_graph.title_cache,
	    graph_templates_graph.lower_limit,
	    graph_templates_graph.upper_limit
	FROM
	    graph_templates_item
	    left join data_template_rrd on (graph_templates_item.task_item_id=data_template_rrd.id)
	    left join graph_templates_graph using(local_graph_id)
	    left join $table using(local_data_id)
	WHERE
	    (graph_templates_item.local_graph_id=$lgi and local_data_id <> \"\")
	LIMIT 1;";
	
    $result=db_fetch_assoc($sql);
    return (!$result || empty($result)) ? false : $result[0]; 
}

function dump($array){
    echo "<pre>";
    print_r($array);
    echo "</pre>";
}

?>
